'''
Print out some informations from the relation dict

@author: rgrzeszi
'''
import numpy as np
import cPickle as pickle

        
def print_stats(relation_dict):
    '''
    Write a comparison/occurrence stat of the top k objects for all scene names
    '''
    
    # Let's first get the number of object and scene names
    
    # The key obj_names stores the list of all objects
    obj_names = relation_dict['obj_names']
    
    # The remaining keys contain the scenes with a list of respective coutns as values
    scene_names = relation_dict.keys()
    scene_names.remove('obj_names')
    
    # Let's print this information
    print "The total number of scene names is:"
    print len(scene_names)
    print "The first ten names are:"
    print scene_names[:10]
    print "**********"
    
    print "The total number of object names is:"
    print len(obj_names)
    print "The first ten names are:"
    print obj_names[:10]
    print "**********"
    
    # Let's get all counts for the scene name street
    print "There are " + str(np.sum(relation_dict['s_street'])) + " relations for scene 'street'" 
        
    # Let's get the specific count for street and car 
    car_idx = obj_names.index('car')
    car_street_count = relation_dict['s_street'][car_idx]
    print "There are " + str(car_street_count) + " relations for Street and Car"
       
    # Let's get the specific count for street and table 
    table_idx = obj_names.index('table')
    table_street_count = relation_dict['s_street'][table_idx]
    print "There are " + str(table_street_count) + " relations for Street and Table"
    print "**********"
    
    print 'The results can be compared with the openie search:'
    print 'http://openie.allenai.org/search?arg1=Street&rel=&arg2=Car&corpora='
    print 'http://openie.allenai.org/search?arg1=Car&rel=&arg2=Street&corpora='
    print '=>    861 + 1360 sentences (11.08.16)'
    
    print 'http://openie.allenai.org/search?arg1=Street&rel=&arg2=Table&corpora='
    print 'http://openie.allenai.org/search?arg1=Table&rel=&arg2=Street&corpora='
    print '=> 4 + 25 sentences (11.08.16)'
    
    return

if __name__ == '__main__':
    relation_dict = pickle.load(open("./openie_relationcounts.cpickle", "rb"))
    # Write the top k file
    print_stats(relation_dict)
    
